<?php 
namespace Teknisa\MAN\Controllers\DataExporterImpl\ReportHandlers;

use Zeedhi\Framework\DTO\Response;

class RelVendaDiaHoraReportHandler extends AReportHandler {
    const RELATORIO = 'vnd02500_relVendasDiaHoraExport';
    
    public function buildNewRequest($request, Response $response) {
        $conditions = $this->relService->getParamsAsArray($request);
        $conditions = $this->buildParams($conditions);
        
        $newRequest = $this->relService->createNewZeedhiFilterRequestObject($request, self::RELATORIO, $conditions);
        
        return [$newRequest, $response];
    }
    
    public function buildParams($conditions) {
        if(!array_key_exists('CDFILIAL', $conditions)) {
            $conditions['CDFILIAL'] = '';
        } else {
            $conditions['CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
            $conditions['CDOPERADOR'] = '';
        }
        
        if(!array_key_exists('CDLOJA', $conditions)) {
            $conditions['CDLOJA'] = '';
            $conditions['TCDLOJA'] = 'T';
        } else {
            $conditions['CDLOJA'] = implode('_', $conditions['CDLOJA']);
            $conditions['TCDLOJA'] = '';
        }
        
        if(array_key_exists('DTPERIODO', $conditions)) {
            $conditions['DATAINI'] = $conditions['DTPERIODO'][0];
            $conditions['DATAFIN'] = $conditions['DTPERIODO'][1];

            unset($conditions['DTPERIODO']);
        }
        
        if(array_key_exists('HRINI', $conditions)) {
            $conditions['HRINI'] = str_replace(['%', ':'], '', $conditions['HRINI']);
        }
        
        if(array_key_exists('HRFIN', $conditions)) {
            $conditions['HRFIN'] = str_replace(['%', ':'], '', $conditions['HRFIN']);
        }
        
        if(array_key_exists('MINUTOS', $conditions)) {
            $conditions['MINUTOS'] = str_replace('%', '', $conditions['MINUTOS']);
        }
        
        if(array_key_exists('IDIMPHR', $conditions)) {
            $conditions['IDIMPHR'] = str_replace('%', '', $conditions['IDIMPHR']);
        }
        
        return $conditions;
    }
}