<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelVendDiaSemanaService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function findConsolidado($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
            ':CDFILIAL'   => $CDFILIAL,
            ':NRORG'      => $NRORG,
            ':CDLOJA'     => $CDLOJA,
            ':TCDLOJA'    => $TCDLOJA,
            ':DTVENDAINI' => $DTVENDAINI,
            ':DTVENDAFIN' => $DTVENDAFIN
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_CONSOLIDADO, $params);
    }
    
    public function findConsolidadoAgrupador1($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
            ':CDFILIAL'   => $CDFILIAL,
            ':NRORG'      => $NRORG,
            ':CDLOJA'     => $CDLOJA,
            ':TCDLOJA'    => $TCDLOJA,
            ':DTVENDAINI' => $DTVENDAINI,
            ':DTVENDAFIN' => $DTVENDAFIN
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_CONSOLIDADO_AGRUPADOR1, $params);
    }
    
    public function findConsolidadoAgrupador2($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
            ':CDFILIAL'   => $CDFILIAL,
            ':NRORG'      => $NRORG,
            ':CDLOJA'     => $CDLOJA,
            ':TCDLOJA'    => $TCDLOJA,
            ':DTVENDAINI' => $DTVENDAINI,
            ':DTVENDAFIN' => $DTVENDAFIN
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_CONSOLIDADO_AGRUPADOR2, $params);
    }
    
    public function findConsolidadoAgrupador3($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
            ':CDFILIAL'   => $CDFILIAL,
            ':NRORG'      => $NRORG,
            ':CDLOJA'     => $CDLOJA,
            ':TCDLOJA'    => $TCDLOJA,
            ':DTVENDAINI' => $DTVENDAINI,
            ':DTVENDAFIN' => $DTVENDAFIN
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_CONSOLIDADO_AGRUPADOR3, $params);
    }
    
    public function findConsolidadoAgrupador4($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
            ':CDFILIAL'   => $CDFILIAL,
            ':NRORG'      => $NRORG,
            ':CDLOJA'     => $CDLOJA,
            ':TCDLOJA'    => $TCDLOJA,
            ':DTVENDAINI' => $DTVENDAINI,
            ':DTVENDAFIN' => $DTVENDAFIN
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_CONSOLIDADO_AGRUPADOR4, $params);
    }
    
    public function findConsolidadoAgrupador5($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
            ':CDFILIAL'   => $CDFILIAL,
            ':NRORG'      => $NRORG,
            ':CDLOJA'     => $CDLOJA,
            ':TCDLOJA'    => $TCDLOJA,
            ':DTVENDAINI' => $DTVENDAINI,
            ':DTVENDAFIN' => $DTVENDAFIN
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_CONSOLIDADO_AGRUPADOR5, $params);
    }
    
    public function findAnalitico($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
         	':CDFILIAL'   => $CDFILIAL,
            ':NRORG'      => $NRORG,
            ':CDLOJA'     => $CDLOJA,
            ':TCDLOJA'    => $TCDLOJA,
         	':DTVENDAINI' => $DTVENDAINI,
         	':DTVENDAFIN' => $DTVENDAFIN
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_ANALITICO, $params);
    }
    
    public function findAnaliticoAgrupador1($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
         	':CDFILIAL'   => $CDFILIAL,
            ':NRORG'      => $NRORG,
            ':CDLOJA'     => $CDLOJA,
            ':TCDLOJA'    => $TCDLOJA,
         	':DTVENDAINI' => $DTVENDAINI,
         	':DTVENDAFIN' => $DTVENDAFIN
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_ANALITICO_AGRUPADOR1, $params);
    }
    
    public function findAnaliticoAgrupador2($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
         	':CDFILIAL'   => $CDFILIAL,
            ':NRORG'      => $NRORG,
            ':CDLOJA'     => $CDLOJA,
            ':TCDLOJA'    => $TCDLOJA,
         	':DTVENDAINI' => $DTVENDAINI,
         	':DTVENDAFIN' => $DTVENDAFIN
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_ANALITICO_AGRUPADOR2, $params);
    }
    
    public function findAnaliticoAgrupador3($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
         	':CDFILIAL'   => $CDFILIAL,
            ':NRORG'      => $NRORG,
            ':CDLOJA'     => $CDLOJA,
            ':TCDLOJA'    => $TCDLOJA,
         	':DTVENDAINI' => $DTVENDAINI,
         	':DTVENDAFIN' => $DTVENDAFIN
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_ANALITICO_AGRUPADOR3, $params);
    }
    
    public function findAnaliticoAgrupador4($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
         	':CDFILIAL'   => $CDFILIAL,
            ':NRORG'      => $NRORG,
            ':CDLOJA'     => $CDLOJA,
            ':TCDLOJA'    => $TCDLOJA,
         	':DTVENDAINI' => $DTVENDAINI,
         	':DTVENDAFIN' => $DTVENDAFIN
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_ANALITICO_AGRUPADOR4, $params);
    }
    
    public function findAnaliticoAgrupador5($CDFILIAL, $NRORG, $CDLOJA, $TCDLOJA, $DTVENDAINI, $DTVENDAFIN) {
        $params = array(
         	':CDFILIAL'   => $CDFILIAL,
            ':NRORG'      => $NRORG,
            ':CDLOJA'     => $CDLOJA,
            ':TCDLOJA'    => $TCDLOJA,
         	':DTVENDAINI' => $DTVENDAINI,
         	':DTVENDAFIN' => $DTVENDAFIN
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_VENDA_DIA_ANALITICO_AGRUPADOR5, $params);
    }

    const GET_VENDA_DIA_CONSOLIDADO = "
        SELECT 'TODAS' AS LABELFILIAL, CDNVPRODUTO, DIASEMANA, SUM(NRCUPONS) AS NRCUPONS, 
            SUM(QTDEPROD) AS QTDEPROD, SUM(VRTOTAL) AS VRTOTAL, SUM(ITENSPERTICK) AS ITENSPERTICK,
            SUM(TICKETMEDIO) AS TICKETMEDIO, SUM(NRPESMESAVENDA) AS NRPESMESAVENDA, SUM(TICKETMEDIOPES) AS TICKETMEDIOPES
        FROM (
        SELECT FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS LABELFILIAL, PP.CDNVPRODUTO, FILOCAVE.CDLOJA,
            FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, FILOCAVE.DIASEMANA AS NUMDIASEMANA,
            CASE
                WHEN FILOCAVE.DIASEMANA = 1
                    THEN 'Domingo'
                WHEN FILOCAVE.DIASEMANA = 2
                    THEN 'Segunda'
                WHEN FILOCAVE.DIASEMANA = 3
                    THEN 'Terça'
                WHEN FILOCAVE.DIASEMANA = 4
                    THEN 'Quarta'
                WHEN FILOCAVE.DIASEMANA = 5
                    THEN 'Quinta'
                WHEN FILOCAVE.DIASEMANA = 6
                    THEN 'Sexta'
                WHEN FILOCAVE.DIASEMANA = 7
                    THEN 'Sábado'
            END AS DIASEMANA, 
            COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
            SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRTOTAL,
            ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
            ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
            (FILOCAVE.NRPESMESAVENDA) AS NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/FILOCAVE.NRPESMESAVENDA),2) AS TICKETMEDIOPES
        FROM ITEMVENDA I
        JOIN PRODUTO PP
            ON I.CDPRODUTO = PP.CDPRODUTO
        LEFT JOIN PRODUTO P4
            ON PP.CDPRODNIVANTE = P4.CDARVPROD
        LEFT JOIN PRODUTO P3
            ON P4.CDPRODNIVANTE = P3.CDARVPROD
        LEFT JOIN PRODUTO P2
            ON P3.CDPRODNIVANTE = P2.CDARVPROD
        LEFT JOIN PRODUTO P1
            ON P2.CDPRODNIVANTE = P1.CDARVPROD
        JOIN (
            SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                    FILOCA.NRORG, SUM(NVL(V.NRPESMESAVENDA, 1)) OVER (PARTITION BY (FILOCA.CDFILIAL||FILOCA.CDLOJA), TO_CHAR(V.DTENTRVENDA,'D')) AS NRPESMESAVENDA
                FROM VENDA V
                    JOIN (
                        SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                            FROM CAIXA C
                                JOIN (
                                    SELECT L.CDLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                        FROM LOJA L
                                            JOIN (
                                                SELECT F.CDFILIAL, F.NRORG, F.NMFILIAL
                                                    FROM FILIAL F
                                                    WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                        AND F.NRORG = :NRORG 
                                            ) FI
                                                ON L.CDFILIAL = FI.CDFILIAL
                                                    AND L.NRORG = FI.NRORG 
                                        WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                                ) FILO
                                    ON C.CDFILIAL = FILO.CDFILIAL
                                        AND C.CDLOJA = FILO.CDLOJA
                                        AND C.NRORG = FILO.NRORG
                    ) FILOCA
                        ON V.CDCAIXA = FILOCA.CDCAIXA
                            AND V.CDLOJA = FILOCA.CDLOJA
                            AND V.CDFILIAL = FILOCA.CDFILIAL
                            AND V.NRORG = FILOCA.NRORG
                WHERE V.IDSITUVENDA = 'O'
                    AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
        ) FILOCAVE
            ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
                AND I.CDFILIAL = FILOCAVE.CDFILIAL
                AND I.CDCAIXA = FILOCAVE.CDCAIXA
                AND I.NRORG = FILOCAVE.NRORG
        GROUP BY FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL, PP.CDNVPRODUTO, FILOCAVE.CDLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
            DIASEMANA, FILOCAVE.NRPESMESAVENDA, PP.CDNVPRODUTO) CONS
        GROUP BY 'TODAS', CDNVPRODUTO, NUMDIASEMANA, DIASEMANA
        ORDER BY NUMDIASEMANA, VRTOTAL
    ";
    
    const GET_VENDA_DIA_CONSOLIDADO_AGRUPADOR1 = "
        SELECT 'TODAS' AS LABELFILIAL, P1.CDNVPRODUTO,
            CASE
                WHEN FILOCAVE.DIASEMANA = 1
                    THEN 'Domingo'
                WHEN FILOCAVE.DIASEMANA = 2
                    THEN 'Segunda'
                WHEN FILOCAVE.DIASEMANA = 3
                    THEN 'Terça'
                WHEN FILOCAVE.DIASEMANA = 4
                    THEN 'Quarta'
                WHEN FILOCAVE.DIASEMANA = 5
                    THEN 'Quinta'
                WHEN FILOCAVE.DIASEMANA = 6
                    THEN 'Sexta'
                WHEN FILOCAVE.DIASEMANA = 7
                    THEN 'Sábado'
            END AS DIASEMANA,
            COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
            SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRTOTAL,
            ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
            ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
            COUNT(FILOCAVE.NRPESMESAVENDA) AS NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/COUNT(FILOCAVE.NRPESMESAVENDA)),2) AS TICKETMEDIOPES,
            P1.CDARVPROD||' - '||P1.NMPRODUTO AS NMARVPRODP1
        FROM ITEMVENDA I
            JOIN PRODUTO PP
                    ON I.CDPRODUTO = PP.CDPRODUTO
                LEFT JOIN PRODUTO P4
                    ON PP.CDPRODNIVANTE = P4.CDARVPROD
                LEFT JOIN PRODUTO P3
                    ON P4.CDPRODNIVANTE = P3.CDARVPROD
                LEFT JOIN PRODUTO P2
                    ON P3.CDPRODNIVANTE = P2.CDARVPROD
                LEFT JOIN PRODUTO P1
                    ON P2.CDPRODNIVANTE = P1.CDARVPROD
            JOIN (
                SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                        FILOCA.NRORG, NVL(V.NRPESMESAVENDA, 1) AS NRPESMESAVENDA
                    FROM VENDA V
                        JOIN ( 
                            SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NRORG
                            FROM CAIXA C
                            JOIN ( 
                                SELECT L.CDLOJA, FI.CDFILIAL, FI.NRORG
                                    FROM LOJA L
                                        JOIN (
                                            SELECT F.CDFILIAL, F.NRORG
                                                FROM FILIAL F
                                                WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                    AND F.NRORG = :NRORG 
                                        ) FI
                                            ON L.CDFILIAL = FI.CDFILIAL
                                                AND L.NRORG = FI.NRORG 
                                    WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                            ) FILO
                                ON C.CDFILIAL = FILO.CDFILIAL
                                    AND C.CDLOJA = FILO.CDLOJA
                                    AND C.NRORG = FILO.NRORG
                        ) FILOCA
                            ON V.CDCAIXA = FILOCA.CDCAIXA
                                AND V.CDLOJA = FILOCA.CDLOJA
                                AND V.CDFILIAL = FILOCA.CDFILIAL
                                AND V.NRORG = FILOCA.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                    AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
            ) FILOCAVE
                ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
                    AND I.CDFILIAL = FILOCAVE.CDFILIAL
                    AND I.CDCAIXA = FILOCAVE.CDCAIXA
                    AND I.NRORG = FILOCAVE.NRORG
        GROUP BY 'TODAS', P1.CDNVPRODUTO, FILOCAVE.DIASEMANA, P1.CDARVPROD||' - '||P1.NMPRODUTO
        ORDER BY FILOCAVE.DIASEMANA, VRTOTAL
    ";
    
    const GET_VENDA_DIA_CONSOLIDADO_AGRUPADOR2 = "
        SELECT 'TODAS' AS LABELFILIAL, P2.CDNVPRODUTO,
            CASE
                WHEN FILOCAVE.DIASEMANA = 1
                    THEN 'Domingo'
                WHEN FILOCAVE.DIASEMANA = 2
                    THEN 'Segunda'
                WHEN FILOCAVE.DIASEMANA = 3
                    THEN 'Terça'
                WHEN FILOCAVE.DIASEMANA = 4
                    THEN 'Quarta'
                WHEN FILOCAVE.DIASEMANA = 5
                    THEN 'Quinta'
                WHEN FILOCAVE.DIASEMANA = 6
                    THEN 'Sexta'
                WHEN FILOCAVE.DIASEMANA = 7
                    THEN 'Sábado'
            END AS DIASEMANA,
            COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
            SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRTOTAL,
            ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
            ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
            COUNT(FILOCAVE.NRPESMESAVENDA) AS NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/COUNT(FILOCAVE.NRPESMESAVENDA)),2) AS TICKETMEDIOPES,
            P2.CDARVPROD||' - '||P2.NMPRODUTO AS NMARVPRODP2
        FROM ITEMVENDA I
            JOIN PRODUTO PP
                    ON I.CDPRODUTO = PP.CDPRODUTO
                LEFT JOIN PRODUTO P4
                    ON PP.CDPRODNIVANTE = P4.CDARVPROD
                LEFT JOIN PRODUTO P3
                    ON P4.CDPRODNIVANTE = P3.CDARVPROD
                LEFT JOIN PRODUTO P2
                    ON P3.CDPRODNIVANTE = P2.CDARVPROD
                LEFT JOIN PRODUTO P1
                    ON P2.CDPRODNIVANTE = P1.CDARVPROD
            JOIN (
                SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                        FILOCA.NRORG, NVL(V.NRPESMESAVENDA, 1) AS NRPESMESAVENDA
                    FROM VENDA V
                        JOIN ( 
                            SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NRORG
                            FROM CAIXA C
                            JOIN ( 
                                SELECT L.CDLOJA, FI.CDFILIAL, FI.NRORG
                                    FROM LOJA L
                                        JOIN (
                                            SELECT F.CDFILIAL, F.NRORG
                                                FROM FILIAL F
                                                WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                    AND F.NRORG = :NRORG 
                                        ) FI
                                            ON L.CDFILIAL = FI.CDFILIAL
                                                AND L.NRORG = FI.NRORG 
                                    WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                            ) FILO
                                ON C.CDFILIAL = FILO.CDFILIAL
                                    AND C.CDLOJA = FILO.CDLOJA
                                    AND C.NRORG = FILO.NRORG
                        ) FILOCA
                            ON V.CDCAIXA = FILOCA.CDCAIXA
                                AND V.CDLOJA = FILOCA.CDLOJA
                                AND V.CDFILIAL = FILOCA.CDFILIAL
                                AND V.NRORG = FILOCA.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                    AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
            ) FILOCAVE
                ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
                    AND I.CDFILIAL = FILOCAVE.CDFILIAL
                    AND I.CDCAIXA = FILOCAVE.CDCAIXA
                    AND I.NRORG = FILOCAVE.NRORG
        GROUP BY 'TODAS', P2.CDNVPRODUTO, FILOCAVE.DIASEMANA, P2.CDARVPROD||' - '||P2.NMPRODUTO
        ORDER BY FILOCAVE.DIASEMANA, VRTOTAL
    ";
    
    const GET_VENDA_DIA_CONSOLIDADO_AGRUPADOR3 = "
        SELECT 'TODAS' AS LABELFILIAL, P3.CDNVPRODUTO,
            CASE
                WHEN FILOCAVE.DIASEMANA = 1
                    THEN 'Domingo'
                WHEN FILOCAVE.DIASEMANA = 2
                    THEN 'Segunda'
                WHEN FILOCAVE.DIASEMANA = 3
                    THEN 'Terça'
                WHEN FILOCAVE.DIASEMANA = 4
                    THEN 'Quarta'
                WHEN FILOCAVE.DIASEMANA = 5
                    THEN 'Quinta'
                WHEN FILOCAVE.DIASEMANA = 6
                    THEN 'Sexta'
                WHEN FILOCAVE.DIASEMANA = 7
                    THEN 'Sábado'
            END AS DIASEMANA,
            COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
            SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRTOTAL,
            ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
            ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
            COUNT(FILOCAVE.NRPESMESAVENDA) AS NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/COUNT(FILOCAVE.NRPESMESAVENDA)),2) AS TICKETMEDIOPES,
            P3.CDARVPROD||' - '||P3.NMPRODUTO AS NMARVPRODP3
        FROM ITEMVENDA I
            JOIN PRODUTO PP
                    ON I.CDPRODUTO = PP.CDPRODUTO
                LEFT JOIN PRODUTO P4
                    ON PP.CDPRODNIVANTE = P4.CDARVPROD
                LEFT JOIN PRODUTO P3
                    ON P4.CDPRODNIVANTE = P3.CDARVPROD
                LEFT JOIN PRODUTO P2
                    ON P3.CDPRODNIVANTE = P2.CDARVPROD
                LEFT JOIN PRODUTO P1
                    ON P2.CDPRODNIVANTE = P1.CDARVPROD
            JOIN (
                SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                        FILOCA.NRORG, NVL(V.NRPESMESAVENDA, 1) AS NRPESMESAVENDA
                    FROM VENDA V
                        JOIN ( 
                            SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NRORG
                            FROM CAIXA C
                            JOIN ( 
                                SELECT L.CDLOJA, FI.CDFILIAL, FI.NRORG
                                    FROM LOJA L
                                        JOIN (
                                            SELECT F.CDFILIAL, F.NRORG
                                                FROM FILIAL F
                                                WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                    AND F.NRORG = :NRORG 
                                        ) FI
                                            ON L.CDFILIAL = FI.CDFILIAL
                                                AND L.NRORG = FI.NRORG 
                                    WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                            ) FILO
                                ON C.CDFILIAL = FILO.CDFILIAL
                                    AND C.CDLOJA = FILO.CDLOJA
                                    AND C.NRORG = FILO.NRORG
                        ) FILOCA
                            ON V.CDCAIXA = FILOCA.CDCAIXA
                                AND V.CDLOJA = FILOCA.CDLOJA
                                AND V.CDFILIAL = FILOCA.CDFILIAL
                                AND V.NRORG = FILOCA.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                    AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
            ) FILOCAVE
                ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
                    AND I.CDFILIAL = FILOCAVE.CDFILIAL
                    AND I.CDCAIXA = FILOCAVE.CDCAIXA
                    AND I.NRORG = FILOCAVE.NRORG
        GROUP BY 'TODAS', P3.CDNVPRODUTO, FILOCAVE.DIASEMANA, P3.CDARVPROD||' - '||P3.NMPRODUTO
        ORDER BY FILOCAVE.DIASEMANA, VRTOTAL
    ";
    
    const GET_VENDA_DIA_CONSOLIDADO_AGRUPADOR4 = "
        SELECT 'TODAS' AS LABELFILIAL, P4.CDNVPRODUTO,
            CASE
                WHEN FILOCAVE.DIASEMANA = 1
                    THEN 'Domingo'
                WHEN FILOCAVE.DIASEMANA = 2
                    THEN 'Segunda'
                WHEN FILOCAVE.DIASEMANA = 3
                    THEN 'Terça'
                WHEN FILOCAVE.DIASEMANA = 4
                    THEN 'Quarta'
                WHEN FILOCAVE.DIASEMANA = 5
                    THEN 'Quinta'
                WHEN FILOCAVE.DIASEMANA = 6
                    THEN 'Sexta'
                WHEN FILOCAVE.DIASEMANA = 7
                    THEN 'Sábado'
            END AS DIASEMANA,
            COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
            SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRTOTAL,
            ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
            ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
            COUNT(FILOCAVE.NRPESMESAVENDA) AS NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/COUNT(FILOCAVE.NRPESMESAVENDA)),2) AS TICKETMEDIOPES,
            P4.CDARVPROD||' - '||P4.NMPRODUTO AS NMARVPRODP4
        FROM ITEMVENDA I
            JOIN PRODUTO PP
                    ON I.CDPRODUTO = PP.CDPRODUTO
                LEFT JOIN PRODUTO P4
                    ON PP.CDPRODNIVANTE = P4.CDARVPROD
                LEFT JOIN PRODUTO P3
                    ON P4.CDPRODNIVANTE = P3.CDARVPROD
                LEFT JOIN PRODUTO P2
                    ON P3.CDPRODNIVANTE = P2.CDARVPROD
                LEFT JOIN PRODUTO P1
                    ON P2.CDPRODNIVANTE = P1.CDARVPROD
            JOIN (
                SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                        FILOCA.NRORG, NVL(V.NRPESMESAVENDA, 1) AS NRPESMESAVENDA
                    FROM VENDA V
                        JOIN ( 
                            SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NRORG
                            FROM CAIXA C
                            JOIN ( 
                                SELECT L.CDLOJA, FI.CDFILIAL, FI.NRORG
                                    FROM LOJA L
                                        JOIN (
                                            SELECT F.CDFILIAL, F.NRORG
                                                FROM FILIAL F
                                                WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                    AND F.NRORG = :NRORG 
                                        ) FI
                                            ON L.CDFILIAL = FI.CDFILIAL
                                                AND L.NRORG = FI.NRORG 
                                    WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                            ) FILO
                                ON C.CDFILIAL = FILO.CDFILIAL
                                    AND C.CDLOJA = FILO.CDLOJA
                                    AND C.NRORG = FILO.NRORG
                        ) FILOCA
                            ON V.CDCAIXA = FILOCA.CDCAIXA
                                AND V.CDLOJA = FILOCA.CDLOJA
                                AND V.CDFILIAL = FILOCA.CDFILIAL
                                AND V.NRORG = FILOCA.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                    AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
            ) FILOCAVE
                ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
                    AND I.CDFILIAL = FILOCAVE.CDFILIAL
                    AND I.CDCAIXA = FILOCAVE.CDCAIXA
                    AND I.NRORG = FILOCAVE.NRORG
        GROUP BY 'TODAS', P4.CDNVPRODUTO, FILOCAVE.DIASEMANA, P4.CDARVPROD||' - '||P4.NMPRODUTO
        ORDER BY FILOCAVE.DIASEMANA, VRTOTAL
    ";
    
    const GET_VENDA_DIA_CONSOLIDADO_AGRUPADOR5 = "
        SELECT 'TODAS' AS LABELFILIAL, PP.CDNVPRODUTO,
            CASE
                WHEN FILOCAVE.DIASEMANA = 1
                    THEN 'Domingo'
                WHEN FILOCAVE.DIASEMANA = 2
                    THEN 'Segunda'
                WHEN FILOCAVE.DIASEMANA = 3
                    THEN 'Terça'
                WHEN FILOCAVE.DIASEMANA = 4
                    THEN 'Quarta'
                WHEN FILOCAVE.DIASEMANA = 5
                    THEN 'Quinta'
                WHEN FILOCAVE.DIASEMANA = 6
                    THEN 'Sexta'
                WHEN FILOCAVE.DIASEMANA = 7
                    THEN 'Sábado'
            END AS DIASEMANA,
            COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
            SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRTOTAL,
            ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
            ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
            COUNT(FILOCAVE.NRPESMESAVENDA) AS NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND,0) + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)))/COUNT(FILOCAVE.NRPESMESAVENDA)),2) AS TICKETMEDIOPES,
            PP.CDARVPROD||' - '||PP.NMPRODUTO AS NMARVPRODP5
        FROM ITEMVENDA I
            JOIN PRODUTO PP
                    ON I.CDPRODUTO = PP.CDPRODUTO
                LEFT JOIN PRODUTO P4
                    ON PP.CDPRODNIVANTE = P4.CDARVPROD
                LEFT JOIN PRODUTO P3
                    ON P4.CDPRODNIVANTE = P3.CDARVPROD
                LEFT JOIN PRODUTO P2
                    ON P3.CDPRODNIVANTE = P2.CDARVPROD
                LEFT JOIN PRODUTO P1
                    ON P2.CDPRODNIVANTE = P1.CDARVPROD
            JOIN (
                SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                        FILOCA.NRORG, NVL(V.NRPESMESAVENDA, 1) AS NRPESMESAVENDA
                    FROM VENDA V
                        JOIN ( 
                            SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NRORG
                            FROM CAIXA C
                            JOIN ( 
                                SELECT L.CDLOJA, FI.CDFILIAL, FI.NRORG
                                    FROM LOJA L
                                        JOIN (
                                            SELECT F.CDFILIAL, F.NRORG
                                                FROM FILIAL F
                                                WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                    AND F.NRORG = :NRORG 
                                        ) FI
                                            ON L.CDFILIAL = FI.CDFILIAL
                                                AND L.NRORG = FI.NRORG 
                                    WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                            ) FILO
                                ON C.CDFILIAL = FILO.CDFILIAL
                                    AND C.CDLOJA = FILO.CDLOJA
                                    AND C.NRORG = FILO.NRORG
                        ) FILOCA
                            ON V.CDCAIXA = FILOCA.CDCAIXA
                                AND V.CDLOJA = FILOCA.CDLOJA
                                AND V.CDFILIAL = FILOCA.CDFILIAL
                                AND V.NRORG = FILOCA.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                    AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
            ) FILOCAVE
                ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
                    AND I.CDFILIAL = FILOCAVE.CDFILIAL
                    AND I.CDCAIXA = FILOCAVE.CDCAIXA
                    AND I.NRORG = FILOCAVE.NRORG
        GROUP BY 'TODAS', PP.CDNVPRODUTO, FILOCAVE.DIASEMANA, PP.CDARVPROD||' - '||PP.NMPRODUTO
        ORDER BY FILOCAVE.DIASEMANA, VRTOTAL
    ";

    const GET_VENDA_DIA_ANALITICO = "
        SELECT FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS LABELFILIAL, PP.CDNVPRODUTO, FILOCAVE.CDLOJA,
            FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
            CASE
                WHEN FILOCAVE.DIASEMANA = 1
                    THEN 'Domingo'
                WHEN FILOCAVE.DIASEMANA = 2
                    THEN 'Segunda'
                WHEN FILOCAVE.DIASEMANA = 3
                    THEN 'Terça'
                WHEN FILOCAVE.DIASEMANA = 4
                    THEN 'Quarta'
                WHEN FILOCAVE.DIASEMANA = 5
                    THEN 'Quinta'
                WHEN FILOCAVE.DIASEMANA = 6
                    THEN 'Sexta'
                WHEN FILOCAVE.DIASEMANA = 7
                    THEN 'Sábado'
            END AS DIASEMANA, 
            COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
            SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRTOTAL,
            ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
            ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
            (FILOCAVE.NRPESMESAVENDA) AS NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/FILOCAVE.NRPESMESAVENDA),2) AS TICKETMEDIOPES
        FROM ITEMVENDA I
        JOIN PRODUTO PP
            ON I.CDPRODUTO = PP.CDPRODUTO
        LEFT JOIN PRODUTO P4
            ON PP.CDPRODNIVANTE = P4.CDARVPROD
        LEFT JOIN PRODUTO P3
            ON P4.CDPRODNIVANTE = P3.CDARVPROD
        LEFT JOIN PRODUTO P2
            ON P3.CDPRODNIVANTE = P2.CDARVPROD
        LEFT JOIN PRODUTO P1
            ON P2.CDPRODNIVANTE = P1.CDARVPROD
        JOIN (
            SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                    FILOCA.NRORG, SUM(NVL(V.NRPESMESAVENDA, 1)) OVER (PARTITION BY (FILOCA.CDFILIAL||FILOCA.CDLOJA), TO_CHAR(V.DTENTRVENDA,'D')) AS NRPESMESAVENDA
                FROM VENDA V
                    JOIN (
                        SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                            FROM CAIXA C
                                JOIN (
                                    SELECT L.CDLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                        FROM LOJA L
                                            JOIN (
                                                SELECT F.CDFILIAL, F.NRORG, F.NMFILIAL
                                                    FROM FILIAL F
                                                    WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                        AND F.NRORG = :NRORG 
                                            ) FI
                                                ON L.CDFILIAL = FI.CDFILIAL
                                                    AND L.NRORG = FI.NRORG 
                                        WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                                ) FILO
                                    ON C.CDFILIAL = FILO.CDFILIAL
                                        AND C.CDLOJA = FILO.CDLOJA
                                        AND C.NRORG = FILO.NRORG
                    ) FILOCA
                        ON V.CDCAIXA = FILOCA.CDCAIXA
                            AND V.CDLOJA = FILOCA.CDLOJA
                            AND V.CDFILIAL = FILOCA.CDFILIAL
                            AND V.NRORG = FILOCA.NRORG
                WHERE V.IDSITUVENDA = 'O'
                    AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
        ) FILOCAVE
            ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
                AND I.CDFILIAL = FILOCAVE.CDFILIAL
                AND I.CDCAIXA = FILOCAVE.CDCAIXA
                AND I.NRORG = FILOCAVE.NRORG
        GROUP BY FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL, PP.CDNVPRODUTO, FILOCAVE.CDLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
            DIASEMANA, FILOCAVE.NRPESMESAVENDA, PP.CDNVPRODUTO
        ORDER BY FILOCAVE.CDFILIAL, FILOCAVE.DIASEMANA, VRTOTAL
    ";
    
    const GET_VENDA_DIA_ANALITICO_AGRUPADOR1 = "
        SELECT FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS LABELFILIAL, FILOCAVE.CDLOJA, P1.CDNVPRODUTO,
            FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
            CASE
                WHEN FILOCAVE.DIASEMANA = 1
                    THEN 'Domingo'
                WHEN FILOCAVE.DIASEMANA = 2
                    THEN 'Segunda'
                WHEN FILOCAVE.DIASEMANA = 3
                    THEN 'Terça'
                WHEN FILOCAVE.DIASEMANA = 4
                    THEN 'Quarta'
                WHEN FILOCAVE.DIASEMANA = 5
                    THEN 'Quinta'
                WHEN FILOCAVE.DIASEMANA = 6
                    THEN 'Sexta'
                WHEN FILOCAVE.DIASEMANA = 7
                    THEN 'Sábado'
            END AS DIASEMANA, 
            COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
            SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRTOTAL,
            ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
            ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
            COUNT(PP.CDPRODUTO) AS NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/COUNT(PP.CDPRODUTO)),2) AS TICKETMEDIOPES,
            P1.CDARVPROD||' - '||P1.NMPRODUTO AS NMARVPRODP1
        FROM ITEMVENDA I
            JOIN PRODUTO PP
                ON I.CDPRODUTO = PP.CDPRODUTO
            LEFT JOIN PRODUTO P4
                ON PP.CDPRODNIVANTE = P4.CDARVPROD
            LEFT JOIN PRODUTO P3
                ON P4.CDPRODNIVANTE = P3.CDARVPROD
            LEFT JOIN PRODUTO P2
                ON P3.CDPRODNIVANTE = P2.CDARVPROD
            LEFT JOIN PRODUTO P1
                ON P2.CDPRODNIVANTE = P1.CDARVPROD
            JOIN (
                SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                        FILOCA.NRORG, SUM(NVL(V.NRPESMESAVENDA, 1)) OVER (PARTITION BY FILOCA.NRORG, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA, 'D')) AS NRPESMESAVENDA
                    FROM VENDA V
                        JOIN (
                            SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                                FROM CAIXA C
                                    JOIN (
                                        SELECT L.CDLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                            FROM LOJA L
                                                JOIN (
                                                    SELECT F.CDFILIAL, F.NRORG, F.NMFILIAL
                                                        FROM FILIAL F
                                                        WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                            AND F.NRORG = :NRORG 
                                                ) FI
                                                    ON L.CDFILIAL = FI.CDFILIAL
                                                        AND L.NRORG = FI.NRORG 
                                            WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                                    ) FILO
                                        ON C.CDFILIAL = FILO.CDFILIAL
                                            AND C.CDLOJA = FILO.CDLOJA
                                            AND C.NRORG = FILO.NRORG
                        ) FILOCA
                            ON V.CDCAIXA = FILOCA.CDCAIXA
                                AND V.CDLOJA = FILOCA.CDLOJA
                                AND V.CDFILIAL = FILOCA.CDFILIAL
                                AND V.NRORG = FILOCA.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                        AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
            ) FILOCAVE
                ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
                    AND I.CDFILIAL = FILOCAVE.CDFILIAL
                    AND I.CDCAIXA = FILOCAVE.CDCAIXA
                    AND I.NRORG = FILOCAVE.NRORG
        GROUP BY FILOCAVE.DIASEMANA, FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
            FILOCAVE.NRPESMESAVENDA, P1.CDNVPRODUTO, P1.CDARVPROD||' - '||P1.NMPRODUTO
        ORDER BY FILOCAVE.CDFILIAL, FILOCAVE.DIASEMANA, VRTOTAL
    ";
    
    const GET_VENDA_DIA_ANALITICO_AGRUPADOR2 = "
        SELECT FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS LABELFILIAL, FILOCAVE.CDLOJA, P2.CDNVPRODUTO,
            FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
            CASE
                WHEN FILOCAVE.DIASEMANA = 1
                    THEN 'Domingo'
                WHEN FILOCAVE.DIASEMANA = 2
                    THEN 'Segunda'
                WHEN FILOCAVE.DIASEMANA = 3
                    THEN 'Terça'
                WHEN FILOCAVE.DIASEMANA = 4
                    THEN 'Quarta'
                WHEN FILOCAVE.DIASEMANA = 5
                    THEN 'Quinta'
                WHEN FILOCAVE.DIASEMANA = 6
                    THEN 'Sexta'
                WHEN FILOCAVE.DIASEMANA = 7
                    THEN 'Sábado'
            END AS DIASEMANA, 
            COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
            SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRTOTAL,
            ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
            ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
            COUNT(PP.CDPRODUTO) AS NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/COUNT(PP.CDPRODUTO)),2) AS TICKETMEDIOPES,
            P2.CDARVPROD||' - '||P2.NMPRODUTO AS NMARVPRODP2
        FROM ITEMVENDA I
            JOIN PRODUTO PP
                ON I.CDPRODUTO = PP.CDPRODUTO
            LEFT JOIN PRODUTO P4
                ON PP.CDPRODNIVANTE = P4.CDARVPROD
            LEFT JOIN PRODUTO P3
                ON P4.CDPRODNIVANTE = P3.CDARVPROD
            LEFT JOIN PRODUTO P2
                ON P3.CDPRODNIVANTE = P2.CDARVPROD
            LEFT JOIN PRODUTO P1
                ON P2.CDPRODNIVANTE = P1.CDARVPROD
            JOIN (
                SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                        FILOCA.NRORG, SUM(NVL(V.NRPESMESAVENDA, 1)) OVER (PARTITION BY FILOCA.NRORG, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA, 'D')) AS NRPESMESAVENDA
                    FROM VENDA V
                        JOIN (
                            SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                                FROM CAIXA C
                                    JOIN (
                                        SELECT L.CDLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                            FROM LOJA L
                                                JOIN (
                                                    SELECT F.CDFILIAL, F.NRORG, F.NMFILIAL
                                                        FROM FILIAL F
                                                        WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                            AND F.NRORG = :NRORG 
                                                ) FI
                                                    ON L.CDFILIAL = FI.CDFILIAL
                                                        AND L.NRORG = FI.NRORG 
                                            WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                                    ) FILO
                                        ON C.CDFILIAL = FILO.CDFILIAL
                                            AND C.CDLOJA = FILO.CDLOJA
                                            AND C.NRORG = FILO.NRORG
                        ) FILOCA
                            ON V.CDCAIXA = FILOCA.CDCAIXA
                                AND V.CDLOJA = FILOCA.CDLOJA
                                AND V.CDFILIAL = FILOCA.CDFILIAL
                                AND V.NRORG = FILOCA.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                        AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
            ) FILOCAVE
                ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
                    AND I.CDFILIAL = FILOCAVE.CDFILIAL
                    AND I.CDCAIXA = FILOCAVE.CDCAIXA
                    AND I.NRORG = FILOCAVE.NRORG
        GROUP BY FILOCAVE.DIASEMANA, FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
            FILOCAVE.NRPESMESAVENDA, P2.CDNVPRODUTO, P2.CDARVPROD||' - '||P2.NMPRODUTO
        ORDER BY FILOCAVE.CDFILIAL, FILOCAVE.DIASEMANA, VRTOTAL
    ";
    
    const GET_VENDA_DIA_ANALITICO_AGRUPADOR3 = "
        SELECT FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS LABELFILIAL, FILOCAVE.CDLOJA, P3.CDNVPRODUTO,
            FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
            CASE
                WHEN FILOCAVE.DIASEMANA = 1
                    THEN 'Domingo'
                WHEN FILOCAVE.DIASEMANA = 2
                    THEN 'Segunda'
                WHEN FILOCAVE.DIASEMANA = 3
                    THEN 'Terça'
                WHEN FILOCAVE.DIASEMANA = 4
                    THEN 'Quarta'
                WHEN FILOCAVE.DIASEMANA = 5
                    THEN 'Quinta'
                WHEN FILOCAVE.DIASEMANA = 6
                    THEN 'Sexta'
                WHEN FILOCAVE.DIASEMANA = 7
                    THEN 'Sábado'
            END AS DIASEMANA, 
            COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
            SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRTOTAL,
            ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
            ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
            COUNT(PP.CDPRODUTO) AS NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/COUNT(PP.CDPRODUTO)),2) AS TICKETMEDIOPES,
            P3.CDARVPROD||' - '||P3.NMPRODUTO AS NMARVPRODP3
        FROM ITEMVENDA I
            JOIN PRODUTO PP
                ON I.CDPRODUTO = PP.CDPRODUTO
            LEFT JOIN PRODUTO P4
                ON PP.CDPRODNIVANTE = P4.CDARVPROD
            LEFT JOIN PRODUTO P3
                ON P4.CDPRODNIVANTE = P3.CDARVPROD
            LEFT JOIN PRODUTO P2
                ON P3.CDPRODNIVANTE = P2.CDARVPROD
            LEFT JOIN PRODUTO P1
                ON P2.CDPRODNIVANTE = P1.CDARVPROD
            JOIN (
                SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                        FILOCA.NRORG, SUM(NVL(V.NRPESMESAVENDA, 1)) OVER (PARTITION BY FILOCA.NRORG, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA, 'D')) AS NRPESMESAVENDA
                    FROM VENDA V
                        JOIN (
                            SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                                FROM CAIXA C
                                    JOIN (
                                        SELECT L.CDLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                            FROM LOJA L
                                                JOIN (
                                                    SELECT F.CDFILIAL, F.NRORG, F.NMFILIAL
                                                        FROM FILIAL F
                                                        WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                            AND F.NRORG = :NRORG 
                                                ) FI
                                                    ON L.CDFILIAL = FI.CDFILIAL
                                                        AND L.NRORG = FI.NRORG 
                                            WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                                    ) FILO
                                        ON C.CDFILIAL = FILO.CDFILIAL
                                            AND C.CDLOJA = FILO.CDLOJA
                                            AND C.NRORG = FILO.NRORG
                        ) FILOCA
                            ON V.CDCAIXA = FILOCA.CDCAIXA
                                AND V.CDLOJA = FILOCA.CDLOJA
                                AND V.CDFILIAL = FILOCA.CDFILIAL
                                AND V.NRORG = FILOCA.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                        AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
            ) FILOCAVE
                ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
                    AND I.CDFILIAL = FILOCAVE.CDFILIAL
                    AND I.CDCAIXA = FILOCAVE.CDCAIXA
                    AND I.NRORG = FILOCAVE.NRORG
        GROUP BY FILOCAVE.DIASEMANA, FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
            FILOCAVE.NRPESMESAVENDA, P3.CDNVPRODUTO, P3.CDARVPROD||' - '||P3.NMPRODUTO
        ORDER BY FILOCAVE.CDFILIAL, FILOCAVE.DIASEMANA, VRTOTAL
    ";
    
    const GET_VENDA_DIA_ANALITICO_AGRUPADOR4 = "
        SELECT FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS LABELFILIAL, FILOCAVE.CDLOJA, P4.CDNVPRODUTO,
            FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
            CASE
                WHEN FILOCAVE.DIASEMANA = 1
                    THEN 'Domingo'
                WHEN FILOCAVE.DIASEMANA = 2
                    THEN 'Segunda'
                WHEN FILOCAVE.DIASEMANA = 3
                    THEN 'Terça'
                WHEN FILOCAVE.DIASEMANA = 4
                    THEN 'Quarta'
                WHEN FILOCAVE.DIASEMANA = 5
                    THEN 'Quinta'
                WHEN FILOCAVE.DIASEMANA = 6
                    THEN 'Sexta'
                WHEN FILOCAVE.DIASEMANA = 7
                    THEN 'Sábado'
            END AS DIASEMANA, 
            COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
            SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRTOTAL,
            ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
            ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
            COUNT(PP.CDPRODUTO) AS NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/COUNT(PP.CDPRODUTO)),2) AS TICKETMEDIOPES,
            P4.CDARVPROD||' - '||P4.NMPRODUTO AS NMARVPRODP4
        FROM ITEMVENDA I
            JOIN PRODUTO PP
                ON I.CDPRODUTO = PP.CDPRODUTO
            LEFT JOIN PRODUTO P4
                ON PP.CDPRODNIVANTE = P4.CDARVPROD
            LEFT JOIN PRODUTO P3
                ON P4.CDPRODNIVANTE = P3.CDARVPROD
            LEFT JOIN PRODUTO P2
                ON P3.CDPRODNIVANTE = P2.CDARVPROD
            LEFT JOIN PRODUTO P1
                ON P2.CDPRODNIVANTE = P1.CDARVPROD
            JOIN (
                SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                        FILOCA.NRORG, SUM(NVL(V.NRPESMESAVENDA, 1)) OVER (PARTITION BY FILOCA.NRORG, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA, 'D')) AS NRPESMESAVENDA
                    FROM VENDA V
                        JOIN (
                            SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                                FROM CAIXA C
                                    JOIN (
                                        SELECT L.CDLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                            FROM LOJA L
                                                JOIN (
                                                    SELECT F.CDFILIAL, F.NRORG, F.NMFILIAL
                                                        FROM FILIAL F
                                                        WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                            AND F.NRORG = :NRORG 
                                                ) FI
                                                    ON L.CDFILIAL = FI.CDFILIAL
                                                        AND L.NRORG = FI.NRORG 
                                            WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                                    ) FILO
                                        ON C.CDFILIAL = FILO.CDFILIAL
                                            AND C.CDLOJA = FILO.CDLOJA
                                            AND C.NRORG = FILO.NRORG
                        ) FILOCA
                            ON V.CDCAIXA = FILOCA.CDCAIXA
                                AND V.CDLOJA = FILOCA.CDLOJA
                                AND V.CDFILIAL = FILOCA.CDFILIAL
                                AND V.NRORG = FILOCA.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                        AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
            ) FILOCAVE
                ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
                    AND I.CDFILIAL = FILOCAVE.CDFILIAL
                    AND I.CDCAIXA = FILOCAVE.CDCAIXA
                    AND I.NRORG = FILOCAVE.NRORG
        GROUP BY FILOCAVE.DIASEMANA, FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
            P4.CDNVPRODUTO, P4.CDARVPROD||' - '||P4.NMPRODUTO
        ORDER BY FILOCAVE.CDFILIAL, FILOCAVE.DIASEMANA, VRTOTAL
    ";
    
    const GET_VENDA_DIA_ANALITICO_AGRUPADOR5 = "
        SELECT FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL AS LABELFILIAL, FILOCAVE.CDLOJA, PP.CDNVPRODUTO,
            FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
            CASE
                WHEN FILOCAVE.DIASEMANA = 1
                    THEN 'Domingo'
                WHEN FILOCAVE.DIASEMANA = 2
                    THEN 'Segunda'
                WHEN FILOCAVE.DIASEMANA = 3
                    THEN 'Terça'
                WHEN FILOCAVE.DIASEMANA = 4
                    THEN 'Quarta'
                WHEN FILOCAVE.DIASEMANA = 5
                    THEN 'Quinta'
                WHEN FILOCAVE.DIASEMANA = 6
                    THEN 'Sexta'
                WHEN FILOCAVE.DIASEMANA = 7
                    THEN 'Sábado'
            END AS DIASEMANA, 
            COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA) AS NRCUPONS,
            SUM(I.QTPRODVEND) AS QTDEPROD, SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)) AS VRTOTAL,
            ROUND(((SUM(I.QTPRODVEND))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS ITENSPERTICK, 
            ROUND(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/(COUNT(DISTINCT FILOCAVE.CDFILIAL||FILOCAVE.CDCAIXA||FILOCAVE.NRSEQVENDA))), 2) AS TICKETMEDIO,
            COUNT(PP.CDPRODUTO) AS NRPESMESAVENDA, TRUNC(((SUM(TRUNC(I.QTPRODVEND * (NVL(I.VRUNITVEND, 0) + NVL(I.VRUNITVENDCL, 0)), 2) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0)))/COUNT(PP.CDPRODUTO)),2) AS TICKETMEDIOPES,
            PP.CDARVPROD||' - '||PP.NMPRODUTO AS NMARVPRODP5
        FROM ITEMVENDA I
            JOIN PRODUTO PP
                ON I.CDPRODUTO = PP.CDPRODUTO
            LEFT JOIN PRODUTO P4
                ON PP.CDPRODNIVANTE = P4.CDARVPROD
            LEFT JOIN PRODUTO P3
                ON P4.CDPRODNIVANTE = P3.CDARVPROD
            LEFT JOIN PRODUTO P2
                ON P3.CDPRODNIVANTE = P2.CDARVPROD
            LEFT JOIN PRODUTO P1
                ON P2.CDPRODNIVANTE = P1.CDARVPROD
            JOIN (
                SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA,'D') DIASEMANA,
                        FILOCA.NRORG, SUM(NVL(V.NRPESMESAVENDA, 1)) OVER (PARTITION BY FILOCA.NRORG, FILOCA.CDLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL, TO_CHAR(V.DTENTRVENDA, 'D')) AS NRPESMESAVENDA
                    FROM VENDA V
                        JOIN (
                            SELECT C.CDCAIXA, FILO.CDLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG
                                FROM CAIXA C
                                    JOIN (
                                        SELECT L.CDLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG
                                            FROM LOJA L
                                                JOIN (
                                                    SELECT F.CDFILIAL, F.NRORG, F.NMFILIAL
                                                        FROM FILIAL F
                                                        WHERE ((INSTR(:CDFILIAL , F.CDFILIAL ) <> 0))
                                                            AND F.NRORG = :NRORG 
                                                ) FI
                                                    ON L.CDFILIAL = FI.CDFILIAL
                                                        AND L.NRORG = FI.NRORG 
                                            WHERE ((INSTR(:CDLOJA, FI.CDFILIAL||L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T'))
                                    ) FILO
                                        ON C.CDFILIAL = FILO.CDFILIAL
                                            AND C.CDLOJA = FILO.CDLOJA
                                            AND C.NRORG = FILO.NRORG
                        ) FILOCA
                            ON V.CDCAIXA = FILOCA.CDCAIXA
                                AND V.CDLOJA = FILOCA.CDLOJA
                                AND V.CDFILIAL = FILOCA.CDFILIAL
                                AND V.NRORG = FILOCA.NRORG
                    WHERE V.IDSITUVENDA = 'O'
                        AND V.DTENTRVENDA BETWEEN :DTVENDAINI AND :DTVENDAFIN
            ) FILOCAVE
                ON I.NRSEQVENDA = FILOCAVE.NRSEQVENDA
                    AND I.CDFILIAL = FILOCAVE.CDFILIAL
                    AND I.CDCAIXA = FILOCAVE.CDCAIXA
                    AND I.NRORG = FILOCAVE.NRORG
        GROUP BY FILOCAVE.DIASEMANA, FILOCAVE.CDFILIAL||' - '||FILOCAVE.NMFILIAL, FILOCAVE.CDLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NMFILIAL, 
            PP.CDNVPRODUTO, PP.CDARVPROD||' - '||PP.NMPRODUTO
        ORDER BY FILOCAVE.CDFILIAL, FILOCAVE.DIASEMANA, VRTOTAL
    ";
}